
/*
------- CHANGELOG --------------------------------------------------------------

	2007-04-03  Kim A. Brandt <kimabrandt@gmx.de>
	* 7122.user.js (URI, ILLEGAL, ..): Renamed a few things.
	(ILLEGAL): Changed a few tags in the ILLEGAL variable that didn't make
	sense.

	2007-08-24  Kim A. Brandt <kimabrandt@gmx.de>
	* 7122.user.js (URI): Extended the regular expression.

	2007-09-11  Kim A. Brandt <kimabrandt@gmx.de>
	* 7122.user.js (UNWANTED): Added a regular expression to sort out
	unwanted results from the uri regex. An example is a
	scheme-only-uri { FAQ: | Changelog: | ... }.
	  It was not a problem of false-positives, but I agree that there is no
	meaning in transforming URIs with only a scheme.
	* 7122.user.js (path-abempty): The segment needed the 0-* operator for
	the pchar non-terminal.
	  Thanks goes to <a href="http://userscripts.org/scripts/show/7122#comment-17680">sharmard</a>.

	2007-09-16  Kim A. Brandt <kimabrandt@gmx.de>
	* 7122.user.js (textToLink): Added the parameter `text'. Now when the
	index > 0 the element.nodeValue is not checked for matches
	{ILLEGAL, URI, ...}. This gives an increase in performance.
	(ILLEGAL, elements): Removed variable ILLEGAL and added its information
	to the XPath expression.

------- REGULAR EXPRESSION -----------------------------------------------------

	I used tab stops of width 8.

	scheme ":"		[a-z][a-z0-9+-.]*:
	hier-part		(
	"//" authority			(\/\/(
	userinfo "@"					(([a-z0-9-._~!$&'()*+,;=:]|%[a-f0-9]{2})*@)?
	host						(
	IP-literal						(
									\[
					
	IPv6address								(
	                           6( h16 ":" ) ls32					(([a-f0-9]{1,4}:){6}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|
	                      "::" 5( h16 ":" ) ls32					(::([a-f0-9]{1,4}:){5}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|
	[               h16 ] "::" 4( h16 ":" ) ls32					(([a-f0-9]{1,4})?::([a-f0-9]{1,4}:){4}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|
	[ *1( h16 ":" ) h16 ] "::" 3( h16 ":" ) ls32					((([a-f0-9]{1,4}:)?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){3}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|
	[ *2( h16 ":" ) h16 ] "::" 2( h16 ":" ) ls32					(((([a-f0-9]{1,4}:){1,2})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){2}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|
	[ *3( h16 ":" ) h16 ] "::"    h16 ":"   ls32					(((([a-f0-9]{1,4}:){1,3})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|
	[ *4( h16 ":" ) h16 ] "::"              ls32					(((([a-f0-9]{1,4}:){1,4})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|
	[ *5( h16 ":" ) h16 ] "::"              h16					(((([a-f0-9]{1,4}:){1,5})?[a-f0-9]{1,4})?::[a-f0-9]{1,4})|
	[ *6( h16 ":" ) h16 ] "::"							(((([a-f0-9]{1,4}:){1,6})?[a-f0-9]{1,4})?::)
										)|
???	IPvFuture								(v[a-f0-9]+\.[a-z0-9-._~!$&'()*+,;=:]+)
									\]
								)|
	IPv4address						((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])|
	reg-name						([a-z0-9-._~!$&'()*+,;=]|%[a-f0-9]{2})*
							)
	":" port					(:[0-9]+)?
						)
	path-abempty				(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*
					)|
	path-absolute			(\/
						(
	segment-nz					([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+
	"/" segment					(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*
						)?
					)|
	path-rootless			(
	segment-nz				([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+
	"/" segment				(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*
					)
				)
	"?" query		(\?([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?
	"#" fragment		(#([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?

------- QUESTIONS --------------------------------------------------------------

	How is IPvFuture suposed to look like? Any URI examples? I ask because I
	couldn't get it to work with the rest of the regular-expression.

------- RESOURCES --------------------------------------------------------------

	Uniform Resource Identifier (URI): Generic Syntax
	http://tools.ietf.org/rfc/rfc3986.txt
	Appendix A.  Collected ABNF for URI
*/

const URI = /[a-z][a-z0-9+-.]*:((\/\/((([a-z0-9-._~!$&'()*+,;=:]|%[a-f0-9]{2})*@)?((\[((([a-f0-9]{1,4}:){6}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(::([a-f0-9]{1,4}:){5}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(([a-f0-9]{1,4})?::([a-f0-9]{1,4}:){4}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|((([a-f0-9]{1,4}:)?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){3}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,2})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){2}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,3})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,4})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,5})?[a-f0-9]{1,4})?::[a-f0-9]{1,4})|(((([a-f0-9]{1,4}:){1,6})?[a-f0-9]{1,4})?::))\])|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])|([a-z0-9-._~!$&'()*+,;=]|%[a-f0-9]{2})*)(:[0-9]+)?)(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*)|(\/(([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*)?)|(([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*))(\?([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?(#([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?/i;
const UNWANTED = /^[a-z][a-z0-9+-.]*:\/*$/i; // SCHEME-ONLY

function main()
{
	var elements = document.evaluate(".//text()[not(parent::a) and not(parent::button) and not(parent::label) and not(parent::legend) and not(parent::option) and not(parent::script) and not(parent::select) and not(parent::style) and not(parent::textarea) and not(parent::title)]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (elements) for (var i = 0; i < elements.snapshotLength; i++) textToLink(elements.snapshotItem(i));
}

function textToLink(element, text)
{
	var index = 0;
	if (!text)
	{
		var matches = element.nodeValue.match(URI);
		if (!matches) return;
		text = matches[0];
		index = element.nodeValue.indexOf(text);
		if (text.search(UNWANTED) > -1)
		{
			index += text.length;
			text = null;
		}
	}
	if (index == 0)
	{
		if (element.nodeValue.length > text.length) textToLink(element.splitText(text.length));
		var link = document.createElement("a");
		link.href = element.nodeValue;
		element.parentNode.insertBefore(link, element);
		link.appendChild(element); // TEXT TO LINK
	}
	else textToLink(element.splitText(index), text);
}

main();
